/*global Util, getLocalVar, Configuration*/
var Cus00900_CustoDePratosController = function (ScreenService, General, GeneralServices, templateManager, maskEngine, ZhUtil) {
    var objetoPrato;
    var self = this;
    
    this.defaultValues = function(widget) {
        if (!widget.currentRow.CDFILIAL) {
            widget.newRow();
        }
        var campoNivel = widget.getField('NMTAMACNIVEL');
        var dataSetNivelPrato = [];


        objetoPrato = General.getLevelByMask('CDPICTPRAT', 1);

        for (var posicao = 0; posicao < objetoPrato.length-(2); posicao ++) {
            dataSetNivelPrato.push(objetoPrato[posicao]);
        }

        campoNivel.dataSource.data = dataSetNivelPrato;

        widget.currentRow.NMTAMACNIVEL = campoNivel.dataSource.data[0].nivel;
        widget.currentRow.NRTAMACNIVEL = campoNivel.dataSource.data[0].caracteres;
        widget.currentRow.CDGRUPFILI = "";

        GeneralServices.retornaTipoCustoPadrao(getLocalVar('CDFILIAL')).then(function(callback) {
            if(callback.dataset.defaulttipocusto[0]) {  
                widget.getField('NMTIPOCUSTO').setValue(callback.dataset.defaulttipocusto[0].CDTIPOCUSTO + ' | ' +callback.dataset.defaulttipocusto[0].NMTIPOCUSTO);
                widget.currentRow.CDTIPOCUSTO = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
            }
        });
    };

    this.toggleServicoAndFilialFields = function(widget) {
        var opcao = widget.currentRow.CDTIPORECE;
        // primeiro aplique o valor default, depois chame a função de toggle e por ultimo mude o readOnly para não
        // dar conflito ou erro
        if(opcao === "P") {
            widget.getField('NMGRUPFILI').applyDefaultValue();
            widget.getField('NMFILIAL').applyDefaultValue();
            widget.getField('ALLNMFILIAL').applyDefaultValue();
            widget.getField('ALLNMFILIAL').checked = true;
            widget.getField('NMSERVICO').applyDefaultValue();
            widget.getField('ALLSERVFILI').applyDefaultValue();
            widget.getField('ALLSERVFILI').checked = true;
            
            General.toggleReadOnlySelect(widget.getField('ALLNMFILIAL'), widget.getField('NMFILIAL'));
            General.toggleReadOnlySelect(widget.getField('ALLSERVFILI'), widget.getField('NMSERVICO'));

            widget.getField('NMGRUPFILI').readOnly    = true;
            widget.getField('NMFILIAL').readOnly      = true;
            widget.getField('ALLNMFILIAL').readOnly   = true;
            widget.getField('NMSERVICO').readOnly     = true;
            widget.getField('ALLSERVFILI').readOnly   = true;
        } else if (opcao === "F") {
            widget.getField('NMSERVICO').applyDefaultValue();
            widget.getField('ALLSERVFILI').applyDefaultValue();
            widget.getField('ALLSERVFILI').checked = true;
            General.toggleReadOnlySelect(widget.getField('ALLSERVFILI'), widget.getField('NMSERVICO'));

            widget.getField('NMGRUPFILI').readOnly    = false;
            widget.getField('NMFILIAL').readOnly      = widget.currentRow.ALLNMFILIAL == 'T' ? true : false;
            widget.getField('ALLNMFILIAL').readOnly   = false;
            widget.getField('NMSERVICO').readOnly     = true;
            widget.getField('ALLSERVFILI').readOnly   = true;

        } else if (opcao === "S") {
            widget.getField('NMSERVICO').applyDefaultValue();
            widget.getField('ALLSERVFILI').applyDefaultValue();
            widget.getField('ALLSERVFILI').checked = true;
            
            General.toggleReadOnlySelect(widget.getField('ALLSERVFILI'), widget.getField('NMSERVICO'));
            
            widget.getField('NMGRUPFILI').readOnly    = false;
            widget.getField('NMFILIAL').readOnly      = widget.currentRow.ALLNMFILIAL == 'T' ? true : false;
            widget.getField('ALLNMFILIAL').readOnly   = false;
            widget.getField('NMSERVICO').readOnly     = true;
            widget.getField('ALLSERVFILI').readOnly   = false;
            
        }
    };

    this.validaNivel = function(currentRow) {

        var mensagem = ScreenService.i18n("O prato final não pode ser menor que o inicial.");
        var retorno  = '';
        
        if(currentRow.CDPRATOINI && currentRow.CDPRATOFIM) {
            retorno = General.comparaPratoProduto(currentRow.CDPRATOINI, currentRow.CDPRATOFIM, getLocalVar('CDPICTPRAT'));
            if (!retorno) {
                ScreenService.showMessage(mensagem);
                return false;
            }
            return true;
        }
        return false;
    };

    this.habilitaSelecaoNivel = function(currentRow, fieldNivel) {
        if (currentRow.ORDENA == '0') {
            fieldNivel.readOnly = true;
            fieldNivel.validations = {};
        } else {
            fieldNivel.readOnly = false;
            fieldNivel.validations = {required: true};
        }
    };

    this.nivelPrato = function(widget) {
        var currentRow = widget.currentRow;
        var nivelPrato = getLocalVar('CDPICTPRAT').split('.').length.toString();

        widget.getField('CDNVPRATO').setValue(nivelPrato);
        currentRow.NRTAMACNIVEL = currentRow.NRTAMACNIVEL;

        if(currentRow.ORDENA == '0') {

            var ultimaPosicao = objetoPrato.length-(1);

            currentRow.TAMCODIGO = objetoPrato[ultimaPosicao].caracteres;
            currentRow.P_NRTAMCODIGO = objetoPrato[ultimaPosicao].caracteres;

        } else {
            // @todo refatorar
            // currentRow.NMTAMACNIVEL.split('.').length;
            currentRow.P_NRTAMCODIGO = 0;

        }

    };

    this.setaFiliCusto = function(widget) {
        widget.getField('CDFILICUSTO').setValue(getLocalVar('CDFILIAL'));
    };

    this.openReport = function(widget, args) {        

        if(widget.isValid() && self.validaNivel(widget.currentRow)) {
        var reportName = widget.currentRow.REPORT_NAME;
        var type = [
					{
						name: "pdf",
						value: "PDF"
					},
					{
						name: "xlsx",
						value: "XLSX"
					}
				];
            self.nivelPrato(widget);
            self.setaFiliCusto(widget);
            General.openReportPopup(widget, self.abreRelatorio, [widget, args, reportName], type);
        }
    };

    this.abreRelatorio = function(widget, args, reportName) {
        widget.currentRow.PRAT_MASK = getLocalVar('CDPICTPRAT');
        args.row.CDPRATOFIM.padEnd(getLocalVar('CDPICTPRAT').split('.').join('').length, 'z');
        
        args.row.NMSERVICO = args.row.NMSERVICO == "" ? [] : args.row.NMSERVICO;
        args.row.NMFILIAL = args.row.NMFILIAL == "" ? [] : args.row.NMFILIAL;
        General.openReport('cus_relatorio#/cus00900_custo_de_pratos', reportName, args.row);
    };
	
	function applyMaskPrat(value){
        let mask = {
            "type": "fix",
            "params": {
                "mask": getLocalVar('CDPICTPRAT')
            }
        };
        return Util.applyMask(value, mask, maskEngine, ZhUtil);
    }
	
	this.setProdIncialAndProdFinal = function(field){
	    var widget = field.widget;
	    var NMPRATOINICIO  = widget.currentRow.NMPRATOINICIO;
	    var NMPRATOFINAL  = widget.currentRow.NMPRATOFINAL;
	    var CDPRATOINI = widget.currentRow.CDPRATOINI ? applyMaskPrat(widget.currentRow.CDPRATOINI) : widget.currentRow.CDPRATOINI;
	    var CDPRATOFIM = widget.currentRow.CDPRATOFIM ? applyMaskPrat(widget.currentRow.CDPRATOFIM) : widget.currentRow.CDPRATOFIM;
	    var fieldPratoIni = widget.getField('NMPRATOINICIO');
	    var fieldPratoFin = widget.getField('NMPRATOFINAL');
	    if(field.name === fieldPratoIni.name && CDPRATOINI) {
            widget.currentRow[fieldPratoFin.name] = CDPRATOINI + ' | ' + NMPRATOINICIO;
            widget.currentRow.CDPRATOFIM = CDPRATOINI;
	        widget.currentRow[fieldPratoIni.name] = CDPRATOINI + ' | ' + NMPRATOINICIO;
	    } else if (field.name === fieldPratoFin.name && CDPRATOFIM){
            widget.currentRow[fieldPratoFin.name] = CDPRATOFIM + ' | ' + NMPRATOFINAL;
	    } else if(field.name === fieldPratoIni.name){
	        widget.currentRow[fieldPratoFin.name] = "";
            widget.currentRow.CDPRATOFIM = "";
	        widget.currentRow[fieldPratoIni.name] = "";
	    } 
	    
	};
	
	this.onChangeAgrup = function(args) {
	    var agrupField = args.owner.field;
	    var widget = agrupField.widget;
	    var filialField = widget.getField('NMFILIAL');
	    
	    filialField.dataSourceFilter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            },
            {
                "name": "CDGRUPFILI",
                "operator": "=",
                "value": agrupField.value() ? widget.currentRow.CDGRUPFILI : "T"
            }
        ];
        
	    filialField.reload();
	    filialField.applyDefaultValue();
	    
	    self.onChangeFilial(widget);
	};
	
	this.onChangeFilial = function(widget) {
	    var agrupField = widget.getField("NMGRUPFILI");
	    var servicoField = widget.getField('NMSERVICO');
	    widget.currentRow.NMFILIAL = widget.currentRow.NMFILIAL == "" ? [] : widget.currentRow.NMFILIAL;
	    if(widget.currentRow.CDTIPORECE == 'S'){
    	    servicoField.dataSourceFilter = [
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": getLocalVar('CDOPERADOR')
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": getLocalVar('NRORG')
                },
                {
                    "name": "CDGRUPFILI",
                    "operator": "=",
                    "value": agrupField.value() ? widget.currentRow.CDGRUPFILI : "T"
                },
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": widget.currentRow.ALLNMFILIAL == "T" ? "T" : widget.currentRow.NMFILIAL.join('_')
                }
            ];
            
            servicoField.reload();
            servicoField.applyDefaultValue();
	    }
	};
	
	this.changeAllFilial = function(args) { 
	    var field = args.owner.field;
	    var widget = field.widget;
	    
	    if(widget.currentRow.CDTIPORECE == 'S'){
	        if(field.value() == "T") {
	            widget.currentRow.NMFILIAL = [];
	            widget.currentRow.CDFILIAL = [];
	        }
            self.onChangeFilial(widget);
	    }
	    General.toggleReadOnlySelect(field, field.widget.getField('NMFILIAL'));
	};
};
Configuration(function(ContextRegister) {
    ContextRegister.register('Cus00900_CustoDePratosController', Cus00900_CustoDePratosController);
});
